#!/bin/bash

###################### MERGE SOURCE TREE  ##########################

if [ $# -lt 1 ]; then
	echo "请输入源分支"
	exit
fi

git reset --hard
THIS_BRANCH=`git branch | grep "*"  | awk -F' ' '{print $2}'`

git checkout -b my_test --force

LAST_VERSION=`git log  -n 1  --pretty="%H" Makefile`
SRC_BRANCH=$1

# 展开合并
git merge $SRC_BRANCH

# 提交合并
COMMIT_MSG=`git shortlog HEAD...${LAST_VERSION}`

git checkout $THIS_BRANCH --force

git merge --no-commit --no-ff $SRC_BRANCH
git commit -s -m "Merge branch $SRC_BRANCH into $THIS_BRANCH

$COMMIT_MSG
"
git branch -D my_test

###################### UPDATE KERNEL VERSION ##########################

# 更新 Makefile 的版本信息
V=`sed -n 's/^EXTRAVERSION = -//p' Makefile`
RC=`sed -n 's/^KYLIN_RC_VERSION = //p' Makefile`

if [ $((RC)) == 0 ]; then
	let NOW=$((V))+1
else
	let NOW=$((V))
fi

# 新增 RC 的版本信息
let RC_NOW=$((RC))+1

# 如果标记为 stable 版本，则强制设置 RC=0
if [ "$2" == "stable" ]; then
	RC_STRING="s1"
	let RC_NOW=0
else
	RC_STRING="rc${RC_NOW}"
fi

sed -i "/EXTRAVERSION =/d" Makefile
sed -i "/SUBLEVEL =/aEXTRAVERSION = -${NOW}" Makefile
sed -i "/KYLIN_RC_VERSION =/d" Makefile
sed -i "/EXTRAVERSION =/aKYLIN_RC_VERSION = ${RC_NOW}" Makefile

VERSION=`sed -n 's/^VERSION = //p' Makefile`
PATCHLEVEL=`sed -n 's/^PATCHLEVEL = //p' Makefile`
SUBLEVEL=`sed -n 's/^SUBLEVEL = //p' Makefile`

TEMPFILE="/tmp/.changelog"

# 新增 Deb changelog 信息
echo "linux (${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${RC_STRING}) v101; urgency=low" > $TEMPFILE
echo "" >> $TEMPFILE
git log HEAD...${LAST_VERSION} --pretty=oneline --pretty="format:  * [%h]" >> $TEMPFILE
echo "" >> $TEMPFILE
echo "" >> $TEMPFILE
echo " -- JackieLiu <liuyun01@kylinos.cn>  `date -R`" >> $TEMPFILE
echo "" >> $TEMPFILE
cat debian.master/changelog >> $TEMPFILE
\mv $TEMPFILE debian.master/changelog

git commit -s -am  "Update kernel version to ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${RC_STRING}

- 更新内核至 ${VERSION}.${PATCHLEVEL}.${SUBLEVEL}-${NOW}.${RC_STRING}"
